// generated by CommonLibrary.cmake, do not edit.

/**
 * @file include/hwsd/net/dns_sd/version.h
 * Defines version macros and class for library hwsd_net_dns_sd.
 */

#ifndef HWSD_NET_DNS_SD_VERSION_H
#define HWSD_NET_DNS_SD_VERSION_H

#include <hwsd/net/dns_sd/api.h>
#include <string>

namespace hwsd
{
    /** The current major version. */
#   define HWSD_VERSION_MAJOR 1

    /** The current minor version. */
#   define HWSD_VERSION_MINOR 3

    /** The current patch level. */
#   define HWSD_VERSION_PATCH 0

    /** The current SCM revision. */
#   define HWSD_VERSION_REVISION 0x0

    /** The current binary interface. */
#   define HWSD_VERSION_ABI 3

/** True if the current version is newer than the given one. */
#   define HWSD_VERSION_GT( MAJOR, MINOR, PATCH )       \
    ( (HWSD_VERSION_MAJOR>MAJOR) ||                     \
      (HWSD_VERSION_MAJOR==MAJOR && (HWSD_VERSION_MINOR>MINOR || \
          (HWSD_VERSION_MINOR==MINOR && HWSD_VERSION_PATCH>PATCH))))

/** True if the current version is equal or newer to the given. */
#   define HWSD_VERSION_GE( MAJOR, MINOR, PATCH )       \
    ( (HWSD_VERSION_MAJOR>MAJOR) ||                     \
      (HWSD_VERSION_MAJOR==MAJOR && (HWSD_VERSION_MINOR>MINOR || \
          (HWSD_VERSION_MINOR==MINOR && HWSD_VERSION_PATCH>=PATCH))))

/** True if the current version is older than the given one. */
#   define HWSD_VERSION_LT( MAJOR, MINOR, PATCH )       \
    ( (HWSD_VERSION_MAJOR<MAJOR) ||                     \
      (HWSD_VERSION_MAJOR==MAJOR && (HWSD_VERSION_MINOR<MINOR || \
          (HWSD_VERSION_MINOR==MINOR && HWSD_VERSION_PATCH<PATCH))))

/** True if the current version is older or equal to the given. */
#   define HWSD_VERSION_LE( MAJOR, MINOR, PATCH )       \
    ( (HWSD_VERSION_MAJOR<MAJOR) ||                     \
      (HWSD_VERSION_MAJOR==MAJOR && (HWSD_VERSION_MINOR<MINOR || \
        (HWSD_VERSION_MINOR==MINOR && HWSD_VERSION_PATCH<=PATCH))))

/** Information about the current hwsd_net_dns_sd version. */
class HWSD_API Version
{
public:
    /** @return the current major version of hwsd_net_dns_sd. */
    static int getMajor();

    /** @return the current minor version of hwsd_net_dns_sd. */
    static int getMinor();

    /** @return the current patch level of hwsd_net_dns_sd. */
    static int getPatch();

    /** @return the current hwsd_net_dns_sd version (MM.mm.pp). */
    static std::string getString();

    /** @return the SCM revision. */
    static int getRevision();

    /** @return the current binary interface version of hwsd_net_dns_sd. */
    static int getABI();

    /** @return the current hwsd_net_dns_sd version plus the git SHA hash (MM.mm.pp.rev). */
    static std::string getRevString();

    /**
     * Runtime check for ABI compatibility.
     *
     * Call from code using hwsd_net_dns_sd. Will fail if the executable
     * was compiled against a version incompatible with the runtime version.
     *
     * @return true if the link-time and compile-time DSO are compatible.
     */
    static bool check()
    {
        return getMajor()==HWSD_VERSION_MAJOR &&
               getMinor()==HWSD_VERSION_MINOR;
    }
};

}

#endif
